Merge "Enable vp8_sad16x16x4d_sse3 in non-RTCD case"
[libvpx.git] / configure
blobf2b42bef472254ce16b42d3a0bee5468ef7ff0b3
1 #!/bin/bash
2 ##
3 ## configure
4 ##
5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
16 source_path=${0%/*}
17 . "${source_path}/build/make/configure.sh"
19 show_help(){
20 show_help_pre
21 cat << EOF
22 Advanced options:
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 ${toggle_fast_unaligned} don't use unaligned accesses, even when
27 supported by hardware [auto]
28 ${toggle_codec_srcs} in/exclude codec library source code
29 ${toggle_debug_libs} in/exclude debug version of libraries
30 ${toggle_eval_limit} enable limited evaluation build
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_psnr} output of PSNR data, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_eval_limit} decoder limitted to 500 frames
37 ${toggle_postproc} postprocessing
38 ${toggle_multithread} multithreaded encoding and decoding.
39 ${toggle_spatial_resampling} spatial sampling (scaling) support
40 ${toggle_realtime_only} enable this option while building for real-time encoding
41 ${toggle_runtime_cpu_detect} runtime cpu detection
42 ${toggle_shared} shared library support
44 Codecs:
45 Codecs can be selectively enabled or disabled individually, or by family:
46 --disable-<codec>
47 is equivalent to:
48 --disable-<codec>-encoder
49 --disable-<codec>-decoder
51 Codecs available in this distribution:
52 EOF
53 #restore editor state '
55 local family;
56 local last_family;
57 local c;
58 local str;
59 for c in ${CODECS}; do
60 family=${c%_*}
61 if [ "${family}" != "${last_family}" ]; then
62 [ -z "${str}" ] || echo "${str}"
63 str="$(printf ' %10s:' ${family})"
65 str="${str} $(printf '%10s' ${c#*_})"
66 last_family=${family}
67 done
68 echo "${str}"
69 show_help_post
73 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
76 # all_platforms is a list of all supported target platforms. Maintain
77 # alphabetically by architecture, generic-gnu last.
78 all_platforms="${all_platforms} armv5te-linux-rvct"
79 all_platforms="${all_platforms} armv5te-linux-gcc"
80 all_platforms="${all_platforms} armv5te-symbian-gcc"
81 all_platforms="${all_platforms} armv5te-wince-vs8"
82 all_platforms="${all_platforms} armv6-darwin-gcc"
83 all_platforms="${all_platforms} armv6-linux-rvct"
84 all_platforms="${all_platforms} armv6-linux-gcc"
85 all_platforms="${all_platforms} armv6-symbian-gcc"
86 all_platforms="${all_platforms} armv6-wince-vs8"
87 all_platforms="${all_platforms} iwmmxt-linux-rvct"
88 all_platforms="${all_platforms} iwmmxt-linux-gcc"
89 all_platforms="${all_platforms} iwmmxt-wince-vs8"
90 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
91 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
92 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
93 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
94 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
95 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
96 all_platforms="${all_platforms} mips32-linux-gcc"
97 all_platforms="${all_platforms} ppc32-darwin8-gcc"
98 all_platforms="${all_platforms} ppc32-darwin9-gcc"
99 all_platforms="${all_platforms} ppc64-darwin8-gcc"
100 all_platforms="${all_platforms} ppc64-darwin9-gcc"
101 all_platforms="${all_platforms} ppc64-linux-gcc"
102 all_platforms="${all_platforms} x86-darwin8-gcc"
103 all_platforms="${all_platforms} x86-darwin8-icc"
104 all_platforms="${all_platforms} x86-darwin9-gcc"
105 all_platforms="${all_platforms} x86-darwin9-icc"
106 all_platforms="${all_platforms} x86-linux-gcc"
107 all_platforms="${all_platforms} x86-linux-icc"
108 all_platforms="${all_platforms} x86-solaris-gcc"
109 all_platforms="${all_platforms} x86-win32-gcc"
110 all_platforms="${all_platforms} x86-win32-vs7"
111 all_platforms="${all_platforms} x86-win32-vs8"
112 all_platforms="${all_platforms} x86_64-darwin9-gcc"
113 all_platforms="${all_platforms} x86_64-linux-gcc"
114 all_platforms="${all_platforms} x86_64-solaris-gcc"
115 all_platforms="${all_platforms} x86_64-win64-vs8"
116 all_platforms="${all_platforms} universal-darwin8-gcc"
117 all_platforms="${all_platforms} universal-darwin9-gcc"
118 all_platforms="${all_platforms} generic-gnu"
120 # all_targets is a list of all targets that can be configured
121 # note that these should be in dependency order for now.
122 all_targets="libs examples docs"
124 # all targets available are enabled, by default.
125 for t in ${all_targets}; do
126 [ -f ${source_path}/${t}.mk ] && enable ${t}
127 done
129 # check installed doxygen version
130 doxy_version=$(doxygen --version 2>/dev/null)
131 doxy_major=${doxy_version%%.*}
132 if [ ${doxy_major:-0} -ge 1 ]; then
133 doxy_version=${doxy_version#*.}
134 doxy_minor=${doxy_version%%.*}
135 doxy_patch=${doxy_version##*.}
137 [ $doxy_major -gt 1 ] && enable doxygen
138 [ $doxy_minor -gt 5 ] && enable doxygen
139 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
142 # install everything except the sources, by default. sources will have
143 # to be enabled when doing dist builds, since that's no longer a common
144 # case.
145 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
146 enable install_bins
147 enable install_libs
149 enable optimizations
150 enable fast_unaligned #allow unaligned accesses, if supported by hw
151 enable md5
152 enable spatial_resampling
153 enable multithread
155 [ -d ${source_path}/../include ] && enable alt_tree_layout
156 for d in vp8; do
157 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
158 done
160 if ! enabled alt_tree_layout; then
161 # development environment
162 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
163 else
164 # customer environment
165 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
166 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
168 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
171 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
172 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
174 ARCH_LIST="
176 mips
178 x86_64
179 ppc32
180 ppc64
182 ARCH_EXT_LIST="
183 armv5te
184 armv6
185 armv7
186 iwmmxt
187 iwmmxt2
189 mips32
193 sse2
194 sse3
195 ssse3
197 altivec
199 HAVE_LIST="
200 ${ARCH_EXT_LIST}
201 vpx_ports
202 stdint_h
203 alt_tree_layout
204 pthread_h
205 sys_mman_h
207 CONFIG_LIST="
208 external_build
209 install_docs
210 install_bins
211 install_libs
212 install_srcs
213 debug
214 gprof
215 gcov
216 rvct
218 msvs
220 big_endian
222 codec_srcs
223 debug_libs
224 fast_unaligned
225 mem_manager
226 mem_tracker
227 mem_checks
230 dequant_tokens
231 dc_recon
232 new_tokens
233 eval_limit
234 runtime_cpu_detect
235 postproc
236 postproc_generic
237 multithread
238 psnr
239 ${CODECS}
240 ${CODEC_FAMILIES}
241 encoders
242 decoders
243 static_msvcrt
244 spatial_resampling
245 realtime_only
246 shared
248 CMDLINE_SELECT="
249 extra_warnings
250 werror
251 install_docs
252 install_bins
253 install_libs
254 install_srcs
255 debug
256 gprof
257 gcov
259 optimizations
260 ccache
261 runtime_cpu_detect
263 libs
264 examples
265 libc
266 fast_unaligned
267 codec_srcs
268 debug_libs
271 dequant_tokens
272 dc_recon
273 new_tokens
274 eval_limit
275 postproc
276 postproc_generic
277 multithread
278 psnr
279 ${CODECS}
280 ${CODEC_FAMILIES}
281 static_msvcrt
282 mem_tracker
283 spatial_resampling
284 realtime_only
285 shared
288 process_cmdline() {
289 for opt do
290 optval="${opt#*=}"
291 case "$opt" in
292 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
293 *) process_common_cmdline $opt
295 esac
296 done
299 post_process_cmdline() {
300 local c
302 # If the codec family is disabled, disable all components of that family.
303 # If the codec family is enabled, enable all components of that family.
304 log_echo "Configuring selected codecs"
305 for c in ${CODECS}; do
306 disabled ${c%%_*} && disable ${c}
307 enabled ${c%%_*} && enable ${c}
308 done
310 # Enable all detected codecs, if they haven't been disabled
311 for c in ${CODECS}; do soft_enable $c; done
313 # Enable the codec family if any component of that family is enabled
314 for c in ${CODECS}; do
315 enabled $c && enable ${c%_*}
316 done
318 # Set the {en,de}coders variable if any algorithm in that class is enabled
319 for c in ${CODECS}; do
320 enabled ${c} && enable ${c##*_}s
321 done
327 process_targets() {
328 enabled child || write_common_config_banner
329 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
331 # TODO: add host tools target (obj_int_extract, etc)
333 # For fat binaries, call configure recursively to configure for each
334 # binary architecture to be included.
335 if enabled universal; then
336 # Call configure (ourselves) for each subarchitecture
337 for arch in $fat_bin_archs; do
338 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
339 done
342 # The write_common_config (config.mk) logic is deferred until after the
343 # recursive calls to configure complete, becuase we want our universal
344 # targets to be executed last.
345 write_common_config_targets
346 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
348 # Calculate the default distribution name, based on the enabled features
349 local cf
350 local DIST_DIR=vpx
351 for cf in $CODEC_FAMILIES; do
352 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
353 DIST_DIR="${DIST_DIR}-${cf}"
354 elif enabled ${cf}_encoder; then
355 DIST_DIR="${DIST_DIR}-${cf}cx"
356 elif enabled ${cf}_decoder; then
357 DIST_DIR="${DIST_DIR}-${cf}dx"
359 done
360 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
361 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
362 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
363 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
364 enabled eval_limit && DIST_DIR="${DIST_DIR}-eval"
365 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
366 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
367 case "${tgt_os}" in
368 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
369 DIST_DIR="${DIST_DIR}-${tgt_cc}"
371 esac
372 if [ -f "${source_path}/build/make/version.sh" ]; then
373 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
374 DIST_DIR="${DIST_DIR}-${ver}"
375 ver=${ver%%-*}
376 VERSION_PATCH=${ver##*.}
377 ver=${ver%.*}
378 VERSION_MINOR=${ver##*.}
379 ver=${ver#v}
380 VERSION_MAJOR=${ver%.*}
382 enabled child || cat <<EOF >> config.mk
383 ifeq (\$(MAKECMDGOALS),dist)
384 DIST_DIR?=${DIST_DIR}
385 else
386 DIST_DIR?=\$(DESTDIR)${prefix}
387 endif
388 LIBSUBDIR=${libdir##${prefix}/}
390 VERSION_MAJOR=${VERSION_MAJOR}
391 VERSION_MINOR=${VERSION_MINOR}
392 VERSION_PATCH=${VERSION_PATCH}
395 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
398 # Write makefiles for all enabled targets
400 for tgt in libs examples docs solution; do
401 local tgt_fn="$tgt-$toolchain.mk"
403 if enabled $tgt; then
404 echo "Creating makefiles for ${toolchain} ${tgt}"
405 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
406 #write_${tgt}_config
408 done
412 process_detect() {
413 if enabled shared; then
414 # Can only build shared libs on a subset of platforms. Doing this check
415 # here rather than at option parse time because the target auto-detect
416 # magic happens after the command line has been parsed.
417 enabled linux || die "--enable-shared only supported on ELF for now"
419 if [ -z "$CC" ]; then
420 echo "Bypassing toolchain for environment detection."
421 enable external_build
422 check_header() {
423 log fake_check_header "$@"
424 header=$1
425 shift
426 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
427 disable $var
428 case $header in
429 stdio.h)
430 true;
433 local result=false
434 for d in "$@"; do
435 [ -f "${d##-I}/$header" ] && result=true && break
436 done
437 ${result:-true}
438 esac && enable $var
440 check_ld() {
441 true
444 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
445 check_ld <<EOF || die "Toolchain is unable to link executables"
446 int main(void) {return 0;}
448 # check system headers
449 check_header stdint.h
450 check_header pthread.h
451 check_header sys/mman.h
453 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
456 process_toolchain() {
457 process_common_toolchain
459 # Handle universal binaries for this architecture
460 case $toolchain in
461 universal-darwin*)
462 local darwin_ver=${tgt_os##darwin}
463 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
465 # Intel
466 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
467 if [ $darwin_ver -gt 8 ]; then
468 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
471 esac
474 # Enable some useful compiler flags
475 if enabled gcc; then
476 enabled werror && check_add_cflags -Werror
477 check_add_cflags -Wall
478 check_add_cflags -Wdeclaration-after-statement
479 check_add_cflags -Wdisabled-optimization
480 check_add_cflags -Wpointer-arith
481 check_add_cflags -Wtype-limits
482 check_add_cflags -Wcast-qual
483 enabled extra_warnings || check_add_cflags -Wno-unused
486 if enabled icc; then
487 enabled werror && check_add_cflags -Werror
488 check_add_cflags -Wall
489 check_add_cflags -Wpointer-arith
491 # ICC has a number of floating point optimizations that we disable
492 # in favor of deterministic output WRT to other compilers
493 add_cflags -fp-model precise
496 # Enable extra, harmless warnings. These might provide additional insight
497 # to what the compiler is doing and why, but in general, but they shouldn't
498 # be treated as fatal, even if we're treating warnings as errors.
499 GCC_EXTRA_WARNINGS="
500 -Wdisabled-optimization
501 -Winline
503 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
504 RVCT_EXTRA_WARNINGS="
505 --remarks
507 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
508 if enabled extra_warnings; then
509 for w in ${EXTRA_WARNINGS}; do
510 check_add_cflags ${w}
511 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
512 done
515 # ccache only really works on gcc toolchains
516 enabled gcc || soft_disable ccache
517 if enabled mips; then
518 enable dequant_tokens
519 enable dc_recon
522 # Enable the postbuild target if building for visual studio.
523 case "$tgt_cc" in
524 vs*) enable msvs
525 enable solution
526 vs_version=${tgt_cc##vs}
527 all_targets="${all_targets} solution"
528 INLINE=__inline
529 FORCEINLINE=__forceinline
531 esac
533 # Other toolchain specific defaults
534 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
539 ## END APPLICATION SPECIFIC CONFIGURATION
541 CONFIGURE_ARGS="$@"
542 process "$@"
543 cat <<EOF > ${BUILD_PFX}vpx_config.c
544 static const char* const cfg = "$CONFIGURE_ARGS";
545 const char *vpx_codec_build_config(void) {return cfg;}